/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   table_entry.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_TABLE_ENTRY_H
#define UHDM_TABLE_ENTRY_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class table_entry : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: table_entry();
    virtual ~table_entry() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    table_entry* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    int VpiSize() const { return vpiSize_; }

    bool VpiSize(int data) { vpiSize_ = data; return true;}

    bool VpiValue(const std::string& data);

    const std::string& VpiValue() const;

    unsigned int VpiType() const final { return vpiTableEntry; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmtable_entry; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    int vpiSize_ = 0;

    SymbolFactory::ID vpiValue_ = 0;

  };

  
  class table_entryFactory {
  friend Serializer;
  public:
  table_entry* Make() {
    table_entry* obj = new table_entry();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<table_entry*> objects_;
  };
  
  
  class VectorOftable_entryFactory {
  friend Serializer;
  public:
  std::vector<table_entry*>* Make() {
    std::vector<table_entry*>* obj = new std::vector<table_entry*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<table_entry*>*> objects_;
  };

};

#endif
